// Copyright 16 Aug 1995 Sun Microsystems, Inc. All Rights Reserved.
//
#pragma ident  "@(#)hi.hh	1.25 95/08/16 Sun Microsystems"
// Copyright 16 Aug 1995 Sun Microsystems, Inc. All Rights Reserved.
//
#pragma ident  "@(#)hi.hh	1.25 95/08/16 Sun Microsystems"
// Copyright 23 Jun 1994 Sun Microsystems, Inc. All Rights Reserved.
#pragma ident "@(#)hi.hh	1.5 94/06/23 Sun Microsystems"
/***********************************************************
 *
 *
 * Copyright 1990, 1991, 1992, 1993 NetLabs, Incorporated, 4920 El Camino Real,
 * Los Altos, CA 94022, USA.
 *
 *                       ALL RIGHTS RESERVED
 *
 * This software, and the ideas, mechanisms and algorithms expressed
 * therein, is the intellectual and material property of NetLabs,
 * Incorporated, and is provided for use under applicable license agreement
 * only.  No title to or ownership of the software is hereby transferred.
 * No license to copy, modify, distribute, translate, decompile, reverse
 * engineer or otherwise remanufacture this software except under the above
 * license is granted.
 *
 *  Notice:  Notwithstanding any other lease or license that may pertain to,
 #  or accompany the delivery of, this computer software, the rights of the
 *  Government regarding its use, reproduction and disclosure are as set
 *  forth in Section 52.227-19 of the FARS Computer Software-Restricted
 *  Rights clause.
 *
 *  (c) Copyright 1990, 1991, 1992, 1993 NetLabs, Inc.  Unpublished - all
 *  rights reserved under the Copyright laws of the United States.
 *
 *  RESTRICTED RIGHTS NOTICE:  Use, duplication, or disclosure by the
 *  Government is subject to the restrictions as set forth in subparagraph
 *  (c)(1)(ii) of the Rights in Technical Data and Computer Software clause
 *  at DFARS 52.227-7013.
 *
 *  NetLabs, Inc.
 *  4920 El Camino Real
 *  Los Altos, CA 94022
 *  (415)961-9500
 *
 *  RESTRICTED RIGHTS LEGEND:  This computer software is submitted with
 *  restricted rights.  Use, duplication or disclosure is subject to the
 *  restrictions as set forth in NASA FAR SUP 18-52.227-79 (April 1985)
 *  Commercial Computer Software- Restricted Rights (April 1985). NetLabs,
 *  Inc., 4920 El Camino Real, Los Altos, CA  94022.  If the contract
 *  contains the Clause at 18-52.227-74 "Rights in Data General" then the
 *  "Alternate III" clause applies.
 *
 * Description:
 *      Generic hi-level API definitions.
 *
 * Created:
 *      Tue March 23 01:22:55 1993
 *
 * Author:
 *      Larry Wall <lwall@netlabs.com>
 *
 * $Log: hi.h,v $
 * Revision 1.23  1993/09/15  22:40:27  lwall
 * NETaa09983
 * Moved hiclass_table management to HiClassData {con,de}structors.
 *
 * Revision 1.22  1993/09/12  03:51:15  lwall
 * NETaa09796
 * The album inclusion/exclusion code didn't work with the code to share
 * images with the same name.  Another level of indirection was added
 * within Images to allow creates to reuse any already-existing Image
 * that happened to have the same name.  This had various ramifications.
 *
 * Revision 1.21  1993/06/25  01:18:44  lwall
 * Aded ImageData::sydata.
 *
 * Revision 1.20  1993/06/25  00:38:27  lwall
 * Deleted some misleading comments.
 *
 * Revision 1.19  1993/06/21  23:29:01  lwall
 * Added explicit copyright notice.
 *
 * Revision 1.18  1993/06/18  00:11:23  lwall
 * Made HI API work with new obed.  Too many changes to enumerate here.
 *
 * Revision 1.17  1993/06/11  06:25:56  lwall
 * Made Coder into a handle class.
 *
 * Revision 1.16  1993/06/08  21:11:57  lwall
 * mNETaa08365 NETaa08369
 * Added CurrentEvent::get_eventtype() method.  Moved string  ants to hi.h.
 * Added CurrentEvent::get_eventtype() method.  Moved string  ants to hi.h.
 *
 * Revision 1.15  1993/06/05  09:22:23  lwall
 * Added Coder registries for bug NETaa08319.  Worked around Lucid bug.
 * Straigtened out some differences between document and files.
 *
 * Revision 1.14  1993/05/29  00:42:36  lwall
 *  Added Morf::has_value().
 *
 * Revision 1.13  1993/05/27  23:27:19  lwall
 * Changed was_clobbered() to num_clobbered() to make error count available.
 * Waiters now automatically count pending callbacks in their refcnt.
 * Added header.
 *
 *
 **********************************************************/

#ifndef __HI_H__
#define __HI_H__

#include <basic.hh>
#include <du.hh>
#include <oid.hh>
#include <callback.hh>
#include <sched.hh>
#include <array.hh>
#include <genint.hh>
#include <except.hh>
#include <exceptstd.hh>
#include <hash.hh>
#include <timestamp.hh>
#include <error.hh>
#include <asn1_val.hh>
#include <asn1_type.hh>

enum TrackMode {NOTRACK, SNAP, POLL, TRACK};


typedef DataUnit DU;
typedef const DU& CDU;
typedef const Callback& CCB;
typedef double Timeout;


// Anand 12-20-94
Asn1Value name2oc(DU oc);

//========= Anand 11-29-94 Exposing useful functions

Asn1Value enc(char *module, char *type, char *data);
DU oc2name(  Asn1Value& av);
DU fdn2formal(CDU fdn)  ;
Asn1Value fdn2oi(CDU fdn)  ;
DU oi2fdn(Asn1Value av)  ;

//========= Anand 11-29-94 Exposing useful functions end
// Anand 12-06-94
// Given attr,value pair this function returns a string like
// item:equality:{attr,val} which is used to set a discriminatorConstruct
// The * returned is static memory
char * discriminator_item(char *attr, char *value);

// Anand 12-09-94 
Result tmToAsn1Time(Asn1Value &gt, struct tm *tt);
	/* 
	 * Fields of importance
	 * tt->tm_year + 1900, tt->tm_mon + 1, tt->tm_mday, tt->tm_hour,
	 * tt->tm_min,
	 * tt->tm_sec);
	 */


// This is the actual duration in sec
const Timeout   REAL_DEFAULT_TIMEOUT = 3600.0;
// This is the default to function arguments to indicate default behavior
const Timeout   DEFAULT_TIMEOUT = -12345.0;
const   Callback	NO_CALLBACK;

const DU	duACCESS  ="ACCESS";
const DU	duAPPLICATION_OBJNAME  ="APPLICATION_OBJNAME";
const DU	duAPPLICATION_TYPE  ="APPLICATION_TYPE";
const DU	duATTR_CHANGED  ="ATTR_CHANGED";
const DU	duAUTOIMAGE  ="AUTOIMAGE";
const DU	duBOOT  ="BOOT";
const DU	duCHANGED  ="CHANGED";
const DU	duDEFAULT  ="DEFAULT";
const DU	duDEFAULT_ALLOWED  ="DEFAULT_ALLOWED";
const DU	duDEFAULT_TIMEOUT  ="DEFAULT_TIMEOUT";
const DU	duDERIVATION  ="DERIVATION";
const DU	duDISCONNECTED  ="DISCONNECTED";
const DU	duDOWN  ="DOWN";
const DU	duERROR  ="PMI_ERROR";
const DU	duEXCLUDE  ="EXCLUDE";
const DU	duEXCLUDE_ALLOWED  ="EXCLUDE_ALLOWED";
const DU	duEXISTS  ="EXISTS";
const DU	duFALSE  ="FALSE";
const DU	duIGNORE  ="IGNORE";
const DU	duIGNORE_ALLOWED  ="IGNORE_ALLOWED";
const DU	duIMAGE_EXCLUDED  ="IMAGE_EXCLUDED";
const DU	duIMAGE_INCLUDED  ="IMAGE_INCLUDED";
const DU	duINCLUDE  ="INCLUDE";
const DU	duINCLUDE_ALLOWED  ="INCLUDE_ALLOWED";
const DU	duLAST_ERROR  ="LAST_ERROR";
const DU	duLOCATION  ="LOCATION";
const DU	duMAYBE  ="MAYBE";
const DU	duMISC_EVENT  ="MISC_EVENT";
const DU	duMODIFIABLE  ="MODIFIABLE";
const DU	duMOD_PENDING  ="MOD_PENDING";
const DU	duNICKNAME  ="NICKNAME";
const DU	duNICKNAME_IS_PERMANENT  ="NICKNAME_IS_PERMANENT";
const DU	duNO  ="NO";
const DU	duNONE  ="NONE";
// Anand 12-20-94
const DU	duNOT_LOADED  ="NOT_LOADED";
const DU	duNO_VALUE	="";
const DU	duOBJCLASS  ="OBJCLASS";
const DU	duOBJECT_CREATED  ="OBJECT_CREATED";
const DU	duOBJECT_DESTROYED  ="OBJECT_DESTROYED";
const DU	duOBJNAME  ="OBJNAME";
const DU	duOWNERSHIP  ="OWNERSHIP";
const DU	duEM  ="EM";
const DU	duPLATFORM_NICKNAME  ="PLATFORM_NICKNAME";
const DU	duPLATFORM_OBJNAME  ="PLATFORM_OBJNAME";
const DU	duPLATFORM_TYPE  ="PLATFORM_TYPE";
const DU	duPOLL  ="POLL";
const DU	duRAW_EVENT  ="RAW_EVENT";
const DU	duREPLACE  ="REPLACE";
const DU	duREPLACE_ALLOWED  ="REPLACE_ALLOWED";
const DU	duSHARED  ="SHARED";
const DU	duSHUTDOWN  ="SHUTDOWN";
const DU	duSNAP  ="SNAP";
const DU	duSTATE  ="STATE";
const DU	duTICKET  ="TICKET";
const DU	duTRACK  ="TRACK";
const DU	duTRACKMODE  ="TRACKMODE";
const DU	duTRUE  ="TRUE";
const DU	duUP  ="UP";
const DU	duWAIT  ="WAIT";
const DU	duYES  ="YES";

enum FormatBits {
    USE_NUMERIC_NAMES		= 1,
    OMIT_NEWLINES		= 2,
    USE_C_ESCAPES		= 4,
    USE_EXPLICIT_TYPES		= 8,
    OMIT_SPACES			= 16,
    USE_EXPLICIT_CHOICE		= 65536
};
typedef U32 FBits;

enum PlatformId {
    VOID_PLATFORM_ID,
    D3_PLATFORM_ID
};  

Arraydeclare(DU);

class Waiter;
class WaiterData;
class CurrentEvent;
class CurrentEventData;
class Platform;
class PlatformData;
class Syntax;
class SyntaxData;
class Morf;
class MorfData;
class Image;
class ImageData;
class Album;
class AlbumData;
class AlbumImage;
class AlbumImageData;
class Coder;

#define CURRENTEVENT_MAGIC 0xdeedfeed
#define CURRENTEVENT_FREED 0xabaddeed

void deldu(Ptr p);
void delalbum(Ptr p);
void delimage(Ptr p);
void delsyntax(Ptr p);
void delcoder(Ptr p);

// Anand 12-20-94
U32 hash_oi(Asn1Value *);
void delasn(Ptr );
int cmp_ois(Ptr, Ptr);

Hashdeclare(DU,DU,DU::hash,DU::equiv,deldu,deldu)
Hashdeclare(DU,Album,DU::hash,DU::equiv,deldu,delalbum)

// Anand 12-20-94
Hashdeclare(Asn1Value,Image,hash_oi,cmp_ois,delasn,delimage)
Hashdeclare(DU,Image,DU::hash,DU::equiv,deldu,delimage)

Hashdeclare(DU,Syntax,DU::hash,DU::equiv,deldu,delsyntax)
Hashdeclare(DU,Coder,DU::hash,DU::equiv,deldu,delcoder)

//****************************************************************************
// Encoder/decoder management
//****************************************************************************

class Coder:public Error {
private:
    friend class CoderData;

    CoderData* cod;

public:
    Coder() { cod = 0; }
    Coder(const Coder& other);

    ~Coder();

    Coder&	operator = (const Coder& other);
    operator void*() ;
    int operator !() ;

    DU		get_str(  Morf& mf, FBits fb) ;
    Morf	set_str(Morf& mf, CDU data, FBits fb) ;
};

//****************************************************************************
// Platform management
//****************************************************************************

class Platform:public Error {
private:
    PlatformData	*pld;
    friend class	AlbumData;
    friend class	CoderData;
    friend class	HiClassData;
    friend class	ImageData;
    friend class	MorfData;
    friend class	PlatformData;
    friend class	SyntaxData;
    friend class	CurrentEventData;

public:

    static Platform def_platform;

    static Platform	default_platform();
    static void		set_default_platform(Platform& plat);

    Platform() { pld = 0; }
    Platform(const Platform& other);
    Platform(CDU plattype, CDU nickname = duNO_VALUE);

    ~Platform();

    Platform&	operator = (const Platform& other);

    // Conversions from Platform.

    operator void*() ;
    int operator !() ;

	int		get_connection_fd(); // Anand 11-29-94

	Result	replace_discriminator_classes( Array(DU) object_classes, 
					Array(DU) event_types = DEF_ARRAY_DU);

	// Anand 12-06-94
	Result	replace_discriminator(DU discriminatorConstruct);

    Result	set_prop(CDU key, CDU value);
    DU		get_prop(CDU key);

    // Establish connection to a platform.

    Result	connect(
		    CDU		location,
		    CDU		application_name,
		    const Timeout	to = DEFAULT_TIMEOUT
		);
    Waiter	start_connect(
		    CDU		platform,
		    CDU		application_name,
		    CCB		cb = NO_CALLBACK
		);

    // Tear down connection to a platform.

    Result	disconnect(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	start_disconnect(CCB cb = NO_CALLBACK);

    Result	when(CDU eventname, CCB cb = NO_CALLBACK);
    Syntax	get_when_syntax(CDU eventname);

    PlatformId	get_plat_id() ;
    void*	get_raw_sap() ;
    DU		get_fullname(CDU shortname) ;
    DU		get_shortname(CDU fullname) ;

	Image 	find_image_by_oi(Asn1Value& oi) ;

    Image	find_image_by_objname(CDU name) ;
    Image	find_image_by_nickname(CDU name) ;
    Album	find_album_by_nickname(CDU name) ;

    Coder	get_attr_coder(CDU attrname) ;
    void	set_attr_coder(CDU attrname, Coder cd);

	// Anand 04-14-95
	DU		get_fdn(DU &dn); // Converts from localdn or fdn to fdn
};

//****************************************************************************
// Current Event Management
//****************************************************************************

class CurrentEvent:public Error {
private:
    friend class CurrentEventData;
    friend class WaiterData;

    CurrentEventData* ced;

public:
    CurrentEvent() { ced = 0; }
    CurrentEvent(const CurrentEvent& other);
    CurrentEvent(Ptr calldata);

    ~CurrentEvent();

    CurrentEvent&	operator = (const CurrentEvent& other);

    // Conversions from CurrentEvent.

    operator void*() ;
    int operator !() ;

    Ptr		get_message() ;
    DU		get_event() ;
    Morf	get_event_raw() ;

    Oid		get_oid() ;
    DU		get_name() ;
    DU		get_eventtype() ;
    DU		get_info() ;
    Morf	get_info_raw() ;
    DU		get_time() ;

    DU		get_objname() ;
    DU		get_objclass() ;

    Platform	get_platform() ;
    Album	get_album() ;
    Image	get_image(Boolean create = FALSE) ;

    void	do_nothing();
    void	do_something();

    Boolean	handled() ;
    void	something_to_do(CCB cb, Ptr cdata);

    // These are for use by routines that will return a CurrentEvent.

    void	set_message(Ptr msg);
    void	set_event_raw(  Morf& mf);
    void	set_objname(CDU nm);
    void	set_objclass(CDU cl);
    void	set_time(CDU tm);
    void	set_oid(  Oid& o);
    void	set_name(CDU nm);
    void	set_eventtype(CDU tp);
    void	set_info_raw(const Morf& mf);
    void	set_album(  Album& al);
    void	set_image(const Image& im);
};

//****************************************************************************
// Scheduling.
//****************************************************************************

class Waiter: public Error {
private:
    WaiterData	*wad;

    friend class	AlbumData;
    friend class	ImageData;
    friend class	MorfData;
    friend class	SyntaxData;
    friend class	WaiterData;

public:
    Waiter() { wad = 0; }
    Waiter(const Waiter& other);
    Waiter(Ptr ptrdata, CCB cb, Timeout defto = REAL_DEFAULT_TIMEOUT);

    Waiter(Ptr ptrdata, Boolean reuse = FALSE);	// ref()  ructed ptrs only.
    Ptr ref();		// Create a void* with ++refcnt

    ~Waiter();

    Waiter&	operator = (const Waiter& other);

    // Conversions from Waiter.

    operator void*() ;
    int operator !() ;

    CurrentEvent wait(const Timeout to = DEFAULT_TIMEOUT);

    Result	waitmore(const Timeout to = DEFAULT_TIMEOUT);
    Result	cancel();

    Result	when_done(CCB cb = NO_CALLBACK);
    Result	when_canceled(CCB cb = NO_CALLBACK);
    Result	when_tick(CCB cb = NO_CALLBACK, const Timeout to = 1.0);

    void	complete();
    void	clobber(const ExceptionType* err = 0);

    Boolean	was_completed();
    U32		num_clobbered();
    Timeout	time_remaining() ;

    Ptr		get_data();
    U32		inc();
    U32		dec();
    CurrentEvent get_current_event();
    const ExceptionType* get_except();
};

//****************************************************************************
// Syntax.
//****************************************************************************

class Syntax: public Error {
private:
    SyntaxData		*syd;
    friend class	AlbumData;
    friend class	Array(Syntax);
    friend class	ImageData;
    friend class	MorfData;
    friend class	PlatformData;
    friend class	SyntaxData;

public:
    Syntax() { syd = 0; }

    Syntax(const Syntax& other);
    Syntax(Platform& plat, DU text);
    Syntax(Morf& morf);
    Syntax(CDU attrname, Platform& plat = Platform::def_platform);

    ~Syntax();

    Syntax&	operator = (const Syntax& other);

    // Conversions from Syntax.

    operator void*() ;
    int operator !() ;

    Platform	get_platform() ;
    Boolean	is_list() ;
    Boolean	is_choice() ;
    Boolean	is_any() ;
    DU		get(FBits fb = 0) ;
    Morf	get_raw() ;
    Syntax	expansion() ;
    Syntax	member(DU name = duNO_VALUE) ;
    DU		get_memname() ;
    Array(DU)	get_member_names() ;

    Coder	get_coder() ;
    void	set_coder(Coder cd);
};

//****************************************************************************
// Mysterious Object Related to Framework
//****************************************************************************

class Array(Morf);

class Morf: public Error {
private:
    MorfData		*mfd;
    friend class	AlbumData;
    friend class	Array(Morf);
    friend class	Coder;        // TP 01/13/94
    friend class	CoderData;
    friend class	ImageData;
    friend class	MorfData;
    friend class	PlatformData;
    friend class	SyntaxData;

public:

    Morf() { mfd = 0; }
	Asn1Value	get_value() ;
	void	set_value(Asn1Value&) ; // Anand 03-02-95
    Morf(const Morf& other);

    Morf(Syntax& syn);				// either
    Morf(Syntax& syn, DU data);			// either
    Morf(Syntax& syn,   Array(Morf)& ma);	// list only
    Morf(Syntax& syn,   class Queue(MorfElem)& mq);	// list only
    Morf(CDU attrname, Platform& plat = Platform::def_platform);

    Morf(Ptr ptrdata, Boolean reuse = FALSE);	// ref()  ructed ptrs only.
    Ptr ref();		// Create a void* with ++refcnt

    ~Morf();

    Morf&	operator = (const Morf& other);

    // Conversions from Morf.

    operator void*() ;
    int operator !() ;

    void*	has_value() ;		// either

    int operator == (const Morf& other) ;
    int operator != (const Morf& other) {
	return !(*this == other);
    }

    Syntax	get_syntax() ;		// either list or scalar
    Platform	get_platform() ;		// either

    Boolean	is_list() ;		// either
    Boolean	is_choice() ;		// either
    Boolean	is_any() ;			// either

    Array(Morf)	split_array() ;		// list only
    class Queue(MorfElem) split_queue() ;	// list only
    Morf	extract(DU navigation) ;	// list only
    U32		num_elements() ;		// list only
	
    Morf	set     (CDU data, FBits fb = 0);// either
    Morf	set_str (CDU data, FBits fb = 0);// scalar only
    Morf	set_long(long data);	// scalar only
    Morf	set_gint(GenInt& data);	// scalar only
    Morf	set_dbl (double data);	// scalar only
    Morf	set_any (Morf &data);	// any only

    DU		get(FBits fb = 0) ;	// either
    DU		get_str(FBits fb = 0) ;	// scalar only
    long	get_long() ;		// scalar only
    GenInt	get_gint() ;		// scalar only
    double	get_dbl() ;		// scalar only

    Result	set_memname(CDU name);		// choice only
    DU		get_memname() ;
    Array(DU)	get_member_names() ;
};

class MorfElem : public QueueElem {
public:
    Morf	mf;

    MorfElem(const Morf &m) : mf(m) {}
};

Queuedeclare(MorfElem);

//****************************************************************************
// Image management
//****************************************************************************

class Image: public Error {
private:
    ImageData		*imd;
    friend class	AlbumData;
    friend class	AlbumImage;
    friend class	Array(Image);
    friend class	ImageData;
    friend class	MorfData;
    friend class	PlatformData;
    friend class	SyntaxData;

public:


	// Anand 12-20-94
	Asn1Value get_oi(void);
	Asn1Value get_oc(void);

	// Anand 12-07-94 Sending event using hi-pmi
	// Image should have a valid object class and
	// name prior to calling this function, boot() not necessary

	// Syntax of event_info is based on the event,
	// And parsed accordingly

	// Here this image is the generator of the event
	// This is the only case when a pmi appl is acting in an agent role
	// Since only agents generate events

	Result  send_event(DU event_name, DU event_info=DU(), struct tm *tt=0);
	Result  send_event(DU event_name, Asn1Value &event_info, 
											Asn1Value &time=Asn1Value());

	Result  send_event(DU event_name, struct tm *tt)
	{
		return(send_event(event_name,DU(),tt));
	}

    //  Construction and destruction.
    Image() { imd = 0; }
    Image(const Image& other);
    Image(
	CDU		objname,
	CDU		objclass = duNO_VALUE,
	Platform&	plat = Platform::def_platform
    );

	// Anand 01-12-95
	Image(ImageData *in_imd);

	// Anand 12-20-94
	Image(Asn1Value& oi,Asn1Value &oc=Asn1Value(), 
				Platform&   plat=Platform::def_platform);

    ~Image();

    Image&	operator = (const Image& other);
    Image	snapshot(CDU newnick = duNO_VALUE);

    // Conversions from Image.

    operator void*() ;
    int operator !() ;

    // Name lookups.

    static Image	find_by_nickname(CDU name,
			    Platform& plat = Platform::def_platform);
    static Image	find_by_objname(CDU name,
			    Platform& plat = Platform::def_platform);

	static Image 	find_by_oi(Asn1Value& oi,
			    Platform& plat = Platform::def_platform);

    // Album Iterator.

    AlbumImage	first_album() ;
    U32		num_albums() ;
    Boolean	is_in_album(Album& al) ;

    // Object information.

    DU		get_prop(CDU key) ;
    Result	set_prop(CDU key, CDU value);

    // Short circuit properties.

    DU		get_objname() ;

    DU		get_objclass() ;
    Result	set_objclass(CDU name);

    DU		get_nickname() ;
    Result	set_nickname(CDU nickname);

    DU		get_state() ;

    DU		get_last_error() ;

    Boolean	exists() ;

    // Place where application can store extra info.

    DU		get_userdata(CDU key) ;
    Result	set_userdata(CDU key, CDU value);

    // Attribute information.

    Array(DU)	get_attr_names(Boolean all = FALSE) ;
    U32		get_attr_numerrors() ;

    // Attribute properties.

    DU		get_attr_prop(CDU name, CDU key) ;
    Result	set_attr_prop(CDU name, CDU key, CDU value);

    // Short circuit properties.

    Boolean	attr_exists(CDU name) ;
    Boolean	attr_changed(CDU name) ;

    DU		get_attr_trackmode(CDU name) ;
    DU		get_attr_last_error(CDU name) ;

    // Enable/disable image.

    Result	boot(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	start_boot(CCB cb = NO_CALLBACK);

	// Anand 12-08-94
    Result	boot(Array(DU)	attrlist,Timeout to = DEFAULT_TIMEOUT);
    Waiter	start_boot(Array(DU)	attrlist,CCB cb = NO_CALLBACK);

    Result	shutdown(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	start_shutdown(CCB cb = NO_CALLBACK);

    // Read real attribute values.

    DU		get     (CDU name, FBits fb = 0) ;
    DU		get_str (CDU name, FBits fb = 0) ;
    long	get_long(CDU name) ;
    GenInt	get_gint(CDU name) ;
    double	get_dbl (CDU name) ;
    Morf	get_raw (CDU name) ;

    // Write imaginary attributes.

    Result	set     (CDU name, CDU           val, CDU op = duREPLACE,
	FBits fb = 0);
    Result	set_str (CDU name, CDU           val, CDU op = duREPLACE,
	FBits fb = 0);
    Result	set_long(CDU name, long    val, CDU op = duREPLACE);
    Result	set_gint(CDU name, GenInt& val, CDU op = duREPLACE);
    Result	set_dbl (CDU name, double  val, CDU op = duREPLACE);
    Result	set_raw (CDU name, Morf&   val, CDU op = duREPLACE);

    Result	set_from_ref(Image& refobj);

    // Read imaginary attributes.

    DU		get_set     (CDU name, FBits fb = 0) ;
    DU		get_set_str (CDU name, FBits fb = 0) ;
    long	get_set_long(CDU name) ;
    GenInt	get_set_gint(CDU name) ;
    double	get_set_dbl (CDU name) ;
    Morf	get_set_raw (CDU name) ;

    // Resolve imaginary attributes.

    Result	revert();

    Result	store(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	start_store(CCB cb = NO_CALLBACK);

    // Object creation, known name.

    Result	create(
		      Image&	refobj = Image(),
		    const Timeout		to = DEFAULT_TIMEOUT
		);
    Waiter	start_create(
		      Image&	refobj = Image(),
		    CCB			cb = NO_CALLBACK
		);

    // Object creation, known container object.

    Result	create_within(
		    CDU			container_objname,
		      Image&	refobj = Image(),
		    const Timeout		to = DEFAULT_TIMEOUT
		);
    Waiter	start_create_within(
		    CDU			container_objname,
		      Image&	refobj = Image(),
		    CCB			cb = NO_CALLBACK
		);

    // Object destruction.

    Result	destroy(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	start_destroy(CCB cb = NO_CALLBACK);

    // Miscellaneous object method activation.

    DU		call(
		    CDU 	name,
		    CDU		param,
		    const Timeout	to = DEFAULT_TIMEOUT
		);
    Morf	call_raw(
		    CDU		name,
		    Morf	param,
		    const Timeout	to = DEFAULT_TIMEOUT
		);

    Waiter	start(
		    CDU		name,
		    CDU		param,
		    CCB		cb = NO_CALLBACK
		);
    Waiter	start_raw(
		    CDU		name,
		    Morf	param,
		    CCB		cb = NO_CALLBACK
		);

    Syntax	get_param_syntax(CDU name) ;
    Syntax	get_result_syntax(CDU name) ;

    // Notification.

    Result	when(CDU eventname, CCB cb = NO_CALLBACK);
    Syntax	get_when_syntax(CDU eventname) ;
};

//****************************************************************************
// Album management
//****************************************************************************

class Album: public Error {
private:
    AlbumData		*ald;
    friend class	AlbumData;
    friend class	AlbumImage;
    friend class	Array(Album);
    friend class	ImageData;
    friend class	MorfData;
    friend class	PlatformData;
    friend class	SyntaxData;

public:

    Album() { ald = 0; }
    Album(const Album& other);
    Album(
	CDU nickname,
	Platform& p = Platform::def_platform
    );
    ~Album();

    static Album find_by_nickname(CDU name,
			    Platform& plat = Platform::def_platform);

    Album&	operator = (const Album& other);
    Album	snapshot(CDU newnick = duNO_VALUE);

    // Conversions from Album.

    operator void*() ;
    int operator !() ;

    // Derives derived albums, nulls out enumerated albums.
    DU		get_derivation() ;
    Result	set_derivation(CDU derivation);

    Result	derive(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	start_derive(CCB cb = NO_CALLBACK);

	// Anand 08-15-94
    Result	derive(Array(DU)	attrlist,Timeout to = DEFAULT_TIMEOUT);
    Waiter	start_derive(Array(DU)	attrlist,CCB cb = NO_CALLBACK);

    // Manipulate membership of enumerated albums.
    Result	include(Image& im);
    Result	exclude(Image& im);
    Result	include(Album& al);
    Result	exclude(Album& al);

    Result	clear() { return exclude(*this); }

    // Image Iterator.
    AlbumImage	first_image();
    U32		num_images() ;

    // Album information.

    DU		get_prop(CDU key) ;
    Result	set_prop(CDU key, CDU value);

    // Place where application can store extra info.

    DU		get_userdata(CDU key) ;
    Result	set_userdata(CDU key, CDU value);

    // Iterate over all images.

    Result	all(
		    Result (*f)(Image& im, void* data),
		    void* data = 0
		);

    Result	all_set_prop(CDU key, CDU value);
    Result	all_set_attr_prop(CDU name, CDU key, CDU value);

    Result	all_boot(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	all_start_boot(CCB cb = NO_CALLBACK);
    Result	all_shutdown(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	all_start_shutdown(CCB cb = NO_CALLBACK);

    Result	all_set     (CDU name, CDU           value, CDU op = duREPLACE,
	FBits fb = 0);
    Result	all_set_str (CDU name, CDU           value, CDU op = duREPLACE,
	FBits fb = 0);
    Result	all_set_long(CDU name, long    value, CDU op = duREPLACE);
    Result	all_set_gint(CDU name, GenInt& value, CDU op = duREPLACE);
    Result	all_set_dbl (CDU name, double  value, CDU op = duREPLACE);
    Result	all_set_raw (CDU name, Morf&   value, CDU op = duREPLACE);

    Result	all_set_from_ref(Image& refobj);

    Result	all_revert();

    Result	all_store(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	all_start_store(CCB cb = NO_CALLBACK);

    Result	all_create(  Image& refobj = Image(),
				const Timeout to = DEFAULT_TIMEOUT);
    Waiter	all_start_create(  Image& refobj = Image(),
				CCB cb = NO_CALLBACK);

    Result	all_create_within(
				CDU container_objname,
				  Image& refobj = Image(),
				const Timeout to = DEFAULT_TIMEOUT);
    Waiter	all_start_create_within(
				CDU container_objname,
				  Image& refobj = Image(),
				CCB cb = NO_CALLBACK);

    Result	all_destroy(const Timeout to = DEFAULT_TIMEOUT);
    Waiter	all_start_destroy(CCB cb = NO_CALLBACK);

    Result	all_call(CDU name, CDU param, const Timeout to = DEFAULT_TIMEOUT);
    Waiter	all_start(CDU name, CDU param, CCB cb = NO_CALLBACK);

    Result	all_when(CDU eventname, CCB cb = NO_CALLBACK);

    Result	when(CDU eventname, CCB cb = NO_CALLBACK);
    Syntax	get_when_syntax(CDU eventname) ;
};

//****************************************************************************
// Platform Data
//****************************************************************************

class PlatformData {
protected:
    friend class	AlbumData;
    friend class	CurrentEventData;
    friend class	ImageData;
    friend class	Platform;
    enum PlatformState {DOWN, BOOT, UP, SHUTDOWN};

	int			sockfd; // Anand 11-29-94
    U32			refcnt;
    PlatformId		plat_id;
    DU			type;
    DU			name;
    DU			nickname;
    DU			appl_instance_name;
    DU			ticket;
    DU			loc;
    DU			appl_name;
    Timeout		default_timeout;
    char*		system_id;
    U32			system_id_len;
    PlatformState	state;

    // Hash(DU,Image)	image_table;
	// Anand 12-20-94
	Hash(Asn1Value,Image)  image_table;

    Hash(DU,Image)	image_nick_table;
    Hash(DU,Album)	album_nick_table;
    Hash(DU,Coder)	coder_table;

    PlatformData()
	: refcnt(0), default_timeout(REAL_DEFAULT_TIMEOUT), system_id(0), system_id_len(0),
		state(DOWN)
    {}
    PlatformData(const PlatformId id, DU ty, CDU nick)
	: refcnt(0), default_timeout(REAL_DEFAULT_TIMEOUT), system_id(0), system_id_len(0),
		plat_id(id), type(ty), nickname(nick), state(DOWN)
    {}

    virtual ~PlatformData() {}

    operator Platform();

    virtual Result	set_prop(CDU key, CDU value);
    virtual DU		get_prop(CDU key);

    // Establish connection to a platform.

    virtual Result	connect(
		    CDU		location,
		    CDU		application_name,
		    const Timeout	to = DEFAULT_TIMEOUT
		) = 0;
    virtual Waiter	start_connect(
		    CDU		platform,
		    CDU		application_name,
		    CCB		cb = NO_CALLBACK
		) = 0;

    // Tear down connection to a platform.

    virtual Result	disconnect(const Timeout to = DEFAULT_TIMEOUT) = 0;
    virtual Waiter	start_disconnect(CCB cb = NO_CALLBACK) = 0;

    virtual Result	when(CDU eventname, CCB cb = NO_CALLBACK) = 0;
    virtual Syntax	get_when_syntax(CDU eventname) = 0;

    virtual void*	get_raw_sap() = 0;
    virtual DU		get_fullname(CDU shortname)   = 0;
    virtual DU		get_shortname(CDU fullname)   = 0;
    virtual DU		canonicalize_objname(CDU name)   = 0;

	virtual Image 	find_image_by_oi(Asn1Value& oi) ;

    virtual Image	find_image_by_objname(CDU name)  ;
    virtual Image	find_image_by_nickname(CDU name)  ;
    virtual Album	find_album_by_nickname(CDU name)  ;

    virtual Coder	get_attr_coder(CDU attrname)  ;
    virtual void	set_attr_coder(CDU attrname, Coder cd);

public:
    Timeout eval_timeout(Timeout to) {
	if (to == DEFAULT_TIMEOUT)
	    to = default_timeout;
	if (to <= 0.0)
	    Rthrow(CanceledX("Default timeout forbids operations that wait"),
			0.0);
	return to;
    }
    static ImageData*	imdata(Image &im);
    static AlbumData*	aldata(Album &al);

	// Anand 04-14-95
	DU		get_fdn(DU &dn) // Converts from localdn or fdn to fdn
	{
		if(!dn)	return dn;
		char *dn_str=dn.chp();
		if(dn_str[0]=='/')	return dn;
		if(system_id)	
			return DU::printf("%s/%s",system_id,dn_str);
		return dn;		// Added a missing return.
	}
};

inline Platform::Platform(const Platform& other) {

	set_error(other.get_error_type(),other.get_error_string());

    if (pld = other.pld)
	pld->refcnt++;
}

inline Platform::operator void*() { return pld; }

inline int Platform::operator !() { return !(void*)*this; }

inline PlatformId Platform::get_plat_id() 
{
	if(pld)
		return pld->plat_id;
    return VOID_PLATFORM_ID;
}

inline PlatformData::operator Platform()
{
    Platform pln;
    pln.pld = this;
    refcnt++;
    return pln;
}

//****************************************************************************
// Encoder/decoder data
//****************************************************************************

class CoderData {
protected:
    friend class	Coder;

    U32			refcnt;
    Platform		plat;
public:
    friend class Morf;

    virtual DU		get_str(  Morf& mf, FBits fb) = 0;
    virtual Morf&	set_str(Morf& mf, CDU data, FBits fb) = 0;

    CoderData(  Platform& pl);
    virtual ~CoderData() {}

    operator Coder();

    static MorfData*	mfdata(Morf &mf);
    static PlatformData* pldata(Platform &platform);
};

inline Coder::Coder(const Coder& other) {

	set_error(other.get_error_type(),other.get_error_string());

    if (cod = other.cod)
	cod->refcnt++;
}

inline Coder::operator void*() { return cod; }

inline int Coder::operator !() { return !(void*)*this; }

inline CoderData::operator Coder()
{
    Coder con;
    con.cod = this;
    refcnt++;
    return con;
}

//****************************************************************************
// Current Event Data
//****************************************************************************

class CurrentEventData {
protected:
    friend class	CurrentEvent;
    friend class	AlbumData;
    friend class	WaiterData;

    U32			refcnt;
    U32			magic;
    Boolean		handled;
    Blockage		something;

    Ptr			message;
    Morf		event;
    Oid			oid;
    DU			eventtype;
    DU			name;
    Morf		info;
    DU			time;

    DU			objname;
    DU			objclass;

	// Anand 12-22-94
	Asn1Value	oi; 
	Asn1Value	oc;

    Platform		platform;
    Album		album;
    Image		image;

public:
    CurrentEventData(  Platform& pl, Ptr rm)
	: platform(pl), refcnt(0), message(rm),
	  handled(FALSE), magic(CURRENTEVENT_MAGIC)
    {}

    virtual ~CurrentEventData() {
	something.wakeup();
	magic = CURRENTEVENT_FREED;
    }

    virtual void	set_message(Ptr msg)		{ message = msg; }
    virtual void	set_event_raw(  Morf& mf)	{ event = mf; }
    virtual void	set_objname(CDU nm)		{ objname = nm; }
    virtual void	set_objclass(CDU cl)		{ objclass = cl; }
    virtual void	set_time(CDU tm)		{ time = tm; }
    virtual void	set_oid(  Oid& o)		{ oid = o; }
    virtual void	set_eventtype(CDU tp)		{ eventtype = tp; }
    virtual void	set_name(CDU nm)		{ name = nm; }
    virtual void	set_info_raw(const Morf& mf)	{ info = mf; }
    virtual void	set_album(  Album& al)	{ album = al; }
    virtual void	set_image(const Image& im)	{ image = im; }

    virtual Ptr		get_message()  	{ return message; }
    virtual DU		get_event()  	{return get_event_raw().get(0);}
    virtual Morf	get_event_raw()  	{ return event; }

	virtual Asn1Value	get_oi()	{return oi;}
	virtual Asn1Value	get_oc()	{return oc;}

    virtual DU		get_objname()  	{ return objname; }
    virtual DU		get_objclass()  	{ return objclass; }
    virtual DU		get_time()  	{ return time; }
    virtual Oid		get_oid()  		{ return oid; }
    virtual DU		get_eventtype()  	{ return eventtype; }
    virtual DU		get_name()  	{ return name; }
    virtual DU		get_info()  	{ return get_info_raw().get(0);}
    virtual Morf	get_info_raw()  	{ return info; }

    virtual Platform	get_platform()  	{ return platform; }
    virtual Album	get_album()  	{ return album; }
    virtual Image	get_image(Boolean)   { return image; }

    virtual void	do_nothing()	{ something.purge(); handled = TRUE; }
    virtual void	do_something()	{ something.wakeup_now();handled=TRUE; }

    operator CurrentEvent();

    static PlatformData* pldata(Platform &platform);
    void		something_to_do(CCB cb, Ptr cdata) {
	handled = FALSE;
	something.sleep(cb,cdata);
    }
};

inline CurrentEvent::CurrentEvent(const CurrentEvent& other) {

	set_error(other.get_error_type(),other.get_error_string());

    if (ced = other.ced)
	ced->refcnt++;
}

inline CurrentEvent::operator void*() { return ced; }

inline int CurrentEvent::operator !() { return !(void*)*this; }

inline CurrentEventData::operator CurrentEvent()
{
    CurrentEvent ce;
    ce.ced = this;
    refcnt++;
    return ce;
}

inline CurrentEvent::CurrentEvent(Ptr calldata)
{
    if (!(ced = (CurrentEventData*)calldata))
	return;

    if (ced->magic != CURRENTEVENT_MAGIC) { // If it's gonna blow, blow up here.
	if (ced->magic == CURRENTEVENT_FREED) {
	    ced = 0;
	    Vthrow(InvalidX("CurrentEvent freed before callback!!!"));
	}
	ced = 0;
	Vthrow(InvalidX("Attempt to initialize CurrentEvent with bad pointer"));
    }
    ced->refcnt++;
}

inline Boolean CurrentEvent::handled() 
{
    return !ced || ced->handled;
}

inline void CurrentEvent::something_to_do(CCB cb, Ptr cdata)
{
    if (ced)
	ced->something_to_do(cb, cdata);
}

//****************************************************************************
// Waiter Data
//****************************************************************************

class WaiterData {
protected:
    friend class	Waiter;

    U32			refcnt;
    U32			refptrcnt;
    U32			pending;

    Timeout		def_timeout;
    Timeout		last_timeout;
    ExceptionType* error;
    CurrentEvent	retval;

    Ptr			object;

    Blockage		done;
    Blockage		canceled;

    U32			clobbered;
    Boolean		completed;
    Boolean		timing;
    Timer		ticker;
    TimeStamp		curtain;

    WaiterData(Ptr obj, CCB cb, const Timeout defto);

    virtual ~WaiterData() {
	if (timing)
	    stop_timer();
	if (error)
	    delete (ExceptionType*)error;
    }

    virtual CurrentEvent wait(const Timeout to = DEFAULT_TIMEOUT);

    virtual Result	waitmore(Timeout to = DEFAULT_TIMEOUT);
    virtual Result	cancel();

    virtual Result	when_done(CCB cb = NO_CALLBACK);
    virtual Result	when_canceled(CCB cb = NO_CALLBACK);
    virtual Result	when_tick(CCB cb = NO_CALLBACK, const Timeout to = 1.0);

    static void complete_cb(Ptr userdata, Ptr calldata);
    virtual void complete();
    virtual void clobber(const ExceptionType* err = 0);

    U32		inc() { refcnt++; return pending++; }
    U32		dec()  { --refcnt; return --pending; }

    virtual void start_timer(const Timeout to);
    virtual void stop_timer();
    virtual Timeout time_remaining()  ;

    static void waitmore_cb(Ptr userdata, Ptr calldata);
public:
    operator Waiter();
    CurrentEvent get_current_event();
};

inline Waiter::Waiter(const Waiter& other) {

	set_error(other.get_error_type(),other.get_error_string());

    if (wad = other.wad)
	wad->refcnt++;
}

inline Waiter::Waiter(Ptr obj, CCB cb, Timeout defto) {
    if (defto == 0.0)
	defto = 999999999;
    wad = new WaiterData(obj, cb, defto);
    if (wad)
	wad->refcnt++;
}

inline Waiter::operator void*() { return wad; }

inline int Waiter::operator !() { return !(void*)*this; }

inline WaiterData::operator Waiter()
{
    Waiter wa;
    wa.wad = this;
    refcnt++;
    return wa;
}

inline Ptr
Waiter::get_data()
{
    if (wad)
	return wad->object;
    return 0;
}

inline CurrentEvent
Waiter::get_current_event()
{
    if (wad)
	return wad->retval;
    return 0;
}

inline Boolean Waiter::was_completed() 
{ 
if(wad)
	return wad->completed ; 
return TRUE; 
}
inline U32 Waiter::num_clobbered() 
{ 
if(wad)
	return wad->clobbered ; 
return 0; 
}
inline const ExceptionType* Waiter::get_except() 
{ 
if(wad)
	return wad->error ;
return 0;
}

inline U32 Waiter::inc() 
{ 
if(wad)
	return wad->inc() ; 
return 0; 
}
inline U32 Waiter::dec() 
{ 
if(wad)
	return wad->dec() ; 
return 0; 
}

//****************************************************************************
// Syntax Data
//****************************************************************************

Arraydeclare(Syntax);

class SyntaxData {
protected:
    friend class	Syntax;

    U32			refcnt;
    Platform		plat;
    DU			name;		// Only if a member of a sequence.
    DU			text;		// Cached text representation.
    DU			attrname;	// If syntax of a particular attribute.

    Coder		coder;
    U32			codergen;

    SyntaxData(Platform p, CDU nm = duNO_VALUE)
	: refcnt(0), plat(p), name(nm), codergen(0) {}

    virtual ~SyntaxData() {}

    virtual operator void*()   = 0;

    virtual Boolean	is_list()   = 0;
    virtual Boolean	is_choice()   = 0;
    virtual Boolean	is_any()   = 0;
    virtual DU		get(FBits fb = 0)   = 0;
    virtual Morf	get_raw()   = 0;
    virtual Syntax	expansion()   = 0;
    virtual Syntax	member(DU name)   = 0;
    virtual Array(DU)	get_member_names()   = 0;

    static MorfData*	mfdata(Morf &mf);
    static PlatformData* pldata(Platform &platform);
    void		cache_coder();
public:
    operator Syntax();
};

inline Syntax::operator void*() 
{ 
if(syd)
	return (void*)syd ; 
return 0; 
}

inline int Syntax::operator !() { return !(void*)*this; }

inline Syntax::Syntax(const Syntax& other) {

	set_error(other.get_error_type(),other.get_error_string());

    if (syd = other.syd)
	syd->refcnt++;
}

inline DU Syntax::get_memname() {
    DU tmp;
    if (syd)
	tmp =  syd->name;
    return tmp;
}

inline SyntaxData::operator Syntax()
{
    Syntax syn;
    syn.syd = this;
    refcnt++;
    return syn;
}

//****************************************************************************
// Morf Data
//****************************************************************************

Arraydeclare(Morf);

class MorfData {
protected:
    friend class	Morf;

    U32			refcnt;
    U32			refptrcnt;
    Syntax		syn;

    DU			choice;		// Only if a member of a choice.
    Syntax		choicesyn;	// Only if a member of a choice.

    Coder		coder;
    U32			codergen;

    MorfData()
	: refcnt(0), refptrcnt(0), codergen(0) {}
    MorfData(  Syntax& s)
	: refcnt(0), refptrcnt(0), codergen(0), syn(s) {}

    virtual ~MorfData() {}

    virtual void*	has_value()   = 0;		// either

    virtual int operator == (const Morf& other)   = 0;

    virtual Array(Morf)	split_array()   = 0;	// list only
    virtual Queue(MorfElem) split_queue()   = 0;	// list only
    virtual Morf	extract(CDU navigation)   = 0; // list only
    virtual U32		num_elements()   = 0;	// list only
	
    virtual Morf	set     (CDU data, FBits fb = 0) = 0;// either
    virtual Morf	set_str (CDU data, FBits fb = 0) = 0;// scalar only
    virtual Morf	set_long(long data) = 0;	// scalar only
    virtual Morf	set_gint(GenInt& data) = 0; // scalar only
    virtual Morf	set_dbl (double data) = 0;// scalar only
    virtual Morf	set_any (Morf& data) = 0;	// any only

    virtual DU		get(FBits fb = 0)   = 0;	// either
    virtual DU		get_str(FBits fb = 0)   = 0;// scalar only
    virtual long	get_long()   = 0;		// scalar only
    virtual GenInt	get_gint()   = 0;		// scalar only
    virtual double	get_dbl()   = 0;		// scalar only

    static SyntaxData*	sydata(Syntax &sy);
    static MorfData*	mfdata(const Morf &mf);
    static PlatformData* pldata(Platform &platform);

    virtual Result	set_memname(CDU name) = 0;	// choice only
    virtual Array(DU)	get_member_names()   = 0;
    void		cache_coder();

public:
	virtual	Asn1Value	get_value() =0;
	virtual	void	set_value(Asn1Value&) =0;
    operator Morf();

};

inline Morf::operator void*() 
{
if(mfd)
	return (void*)mfd->syn ;
return (void*)0;
}

inline int Morf::operator !() { return !(void*)*this; }

inline DU Morf::get_memname() 
{
    if (!mfd)
	return DU();

    if (is_choice())
	return mfd->choice;
    else
	return mfd->syn.get_memname();
}

inline MorfData::operator Morf()
{
    Morf mfn;
    mfn.mfd = this;
    refcnt++;
    return mfn;
}

//****************************************************************************
// HiClass management
//****************************************************************************

class HiClassData;

class HiClass: public Error {
private:
    HiClassData	*hcd;

    friend class	AlbumData;
    friend class	HiClassData;
    friend class	ImageData;
    friend class	MorfData;
    friend class	SyntaxData;

public:
    HiClass() { hcd = 0; }
    HiClass(const HiClass& other);
    HiClass(CDU oc, Platform &pl);

    ~HiClass();

    HiClass&	operator = (const HiClass& other);

    // Conversions from HiClass.

    operator void*() ;
    int operator !() ;

    DU			name() ;

    void		load_attr_info(ImageData* imd) ;
};

//****************************************************************************
// HiClass Data
//****************************************************************************

class HiClassData {
protected:
    friend class	HiClass;
    friend class	ImageData;

    U32			refcnt;

    Platform		plat;
    DU			ocname;


    virtual void	load_attr_info(ImageData* imd)   = 0;
    HiClassData(CDU oc,   Platform& pl);

    virtual ~HiClassData();

    DU			name()   { return ocname; }

    static PlatformData* pldata(Platform &platform);
public:
    Array(DU)		names;
    Array(DU)		oids;
    operator HiClass();
};

inline HiClass::HiClass(const HiClass& other) {

	set_error(other.get_error_type(),other.get_error_string());

    if (hcd = other.hcd)
	hcd->refcnt++;
}

inline DU HiClass::name() {
    if (hcd)
	return hcd->name();
    return DU();
}

inline HiClass::operator void*() { return hcd; }

inline int HiClass::operator !() { return !(void*)*this; }

inline HiClassData::operator HiClass()
{
    HiClass hc;
    hc.hcd = this;
    refcnt++;
    return hc;
}

//****************************************************************************
// Attribute management
//****************************************************************************

class AttrTracker : public QueueElem {
public:
    enum AttrOperation {IGNORE,REPLACE,INCLUDE,EXCLUDE,DEFAULT};
    enum AttrExists {NO, MAYBE, YES};

      DU		name;
    Morf		rval;
    Morf		ival;
    DU			last_error;

    AttrOperation	operation;
    AttrExists		existence;
    TrackMode		trackmode;
    Boolean		changed;

    AttrTracker(CDU nm)
	: operation(IGNORE), existence(MAYBE), name(nm), changed(TRUE),
	    trackmode(SNAP)
    {}

    Result		set_op(CDU op);
};

Queuedeclare(AttrTracker);

//****************************************************************************
// ImageElem
//****************************************************************************

class ImageElem : public QueueElem {
private:
    friend class	Album;
    friend class	AlbumImage;
    friend class	AlbumImageData;
    friend class	Image;

public:
    Image	image;
    ImageElem() {}
    ImageElem(  Image& im) : image(im) {}
};

Queuedeclare(ImageElem);

//****************************************************************************
// AlbumElem
//****************************************************************************

class AlbumElem : public QueueElem {
private:
    friend class	Album;
    friend class	AlbumImage;
    friend class	AlbumImageData;
    friend class	Image;

public:
    Album	album;
    AlbumElem() {}
    AlbumElem(  Album& al) : album(al) {}
};

Queuedeclare(AlbumElem);

//****************************************************************************
// AlbumImage
//****************************************************************************

class AlbumImage {
private:
    AlbumImageData	*aid;

    friend class	AlbumData;
    friend class	AlbumImageData;
    friend class	ImageData;
    friend class	MorfData;
    friend class	SyntaxData;
    friend class	WaiterData;

    AlbumImage(  Album& al,   Image& im);

public:
    AlbumImage() { aid = 0; }
    AlbumImage(  AlbumImage& other);
    
    ~AlbumImage();

    AlbumImage&	operator = (const AlbumImage& other);

    // Conversions from AlbumImage.

    operator void*() ;
    int operator !() ;

    AlbumImage next_image();
    AlbumImage next_album();
    void delete_yourself();

    operator Image();
    operator Album();
};

//****************************************************************************
// AlbumImageData
//****************************************************************************

class AlbumImageData : public AlbumElem, public ImageElem {
private:
    friend class	Album;
    friend class	AlbumData;
    friend class	AlbumImage;
    friend class	Image;
    friend class	ImageData;

    U32		refcnt;
    Boolean	deleted;
    Boolean	excludemaybe;

    AlbumImageData();
    AlbumImageData(  Album& al,   Image& im);

    ~AlbumImageData() {}

public:
    operator AlbumImage();
};

inline AlbumImage::AlbumImage(  AlbumImage& other) {
    if (aid = other.aid)
	aid->refcnt++;
}

inline AlbumImage::operator void*() { return aid; }

inline int AlbumImage::operator !() { return !(void*)*this; }

inline AlbumImageData::operator AlbumImage()
{
    AlbumImage ain;
    ain.aid = this;
    refcnt++;
    return ain;
}

inline Image AlbumImage::operator Image() {
    Image tmp;
    if (aid)
	tmp =  aid->image;
    return tmp;
}
inline Album AlbumImage::operator Album() {
    Album tmp;
    if (aid)
	tmp = aid->album;
    return tmp;
}

inline AlbumImageData::AlbumImageData()
    : refcnt(0), deleted(TRUE), excludemaybe(FALSE)
{}
inline AlbumImageData::AlbumImageData(  Album& al,   Image& im)
    : refcnt(0), deleted(FALSE), excludemaybe(FALSE),
	AlbumElem(al), ImageElem(im)
{}

//****************************************************************************
// Image Data
//****************************************************************************

Arraydeclare(Image);

class ImageData {
protected:
    friend class	AlbumData;
    friend class	AlbumImage;
    friend class	HiClassData;
    friend class	HiClass;
    friend class	Image;
    friend class	PlatformData;

    enum ImageState {DOWN, BOOT, UP, SHUTDOWN};
    enum ImageExists {NO, MAYBE, YES};

    U32			refcnt;
    U32			albumcnt;
    Image		redirect;
    DU			oname;
    DU			nickname;
    HiClass		hiclass;
    Platform		plat;

    DU			last_error;
    U32			attr_numerrors;

    Queue(AttrTracker)	attrq;

    Queue(AlbumElem)	alq;

    Hash(DU,DU)		*userdata;

    ImageState		state;
    ImageExists		existence;
    Boolean		nick_is_perm;
    Boolean		nick_changed;
    Boolean		shared;
    Boolean		names_loaded;
    TrackMode		trackmode;

	// Anand 12-20-94
	virtual Asn1Value	get_oi(void) =0;
	virtual Asn1Value	get_oc(void) ;
	virtual	Result  send_event(DU event_name, DU event_info=DU(),struct tm *tt=0)=0;
	virtual	Result  send_event(DU event_name, Asn1Value &event_info, Asn1Value &tm)=0;
    ImageData()
	: refcnt(0), albumcnt(0), state(DOWN), existence(MAYBE),
	    nick_is_perm(FALSE), nick_changed(FALSE), names_loaded(FALSE),
	    attr_numerrors(0), trackmode(SNAP), shared(TRUE), userdata(0)
    {}

	// Anand 12-20-94
	// Deleted one with DUs
    ImageData(Asn1Value &oi, Asn1Value& oc, Platform &pl);


    virtual ~ImageData()
    {
	if (userdata)
	    delete userdata;
    }

    virtual Image	snapshot(CDU newnick = duNO_VALUE);

    // Album Iterator.
    AlbumImage		first_album()  ;
    U32			num_albums()  ;
    Boolean		is_in_album(Album& al) ;

    // Object information.

    virtual DU		get_prop(CDU key) ;
    virtual Result	set_prop(CDU key, CDU value);

    // Short circuit properties.

    virtual DU		get_objname() ;

    virtual DU		get_objclass() ;
    virtual Result	set_objclass(CDU name);

    virtual DU		get_nickname() ;
    virtual Result	set_nickname(CDU nickname);

    virtual DU		get_state() ;

    virtual DU		get_last_error() ;

    virtual Boolean	exists() ;

    // Place where application can store extra info.

    virtual DU		get_userdata(CDU key)  ;
    virtual Result	set_userdata(CDU key, CDU value);

    // Attribute information.

    virtual Array(DU)	get_attr_names(Boolean all = FALSE) ;
    virtual U32		get_attr_numerrors()  ;

    // Attribute properties.

    virtual DU		get_attr_prop(CDU name, CDU key) ;
    virtual Result	set_attr_prop(CDU name, CDU key, CDU value);

    // Short circuit properties.

    virtual Boolean	attr_exists(CDU name) ;
    virtual Boolean	attr_changed(CDU name) ;

    virtual DU		get_attr_trackmode(CDU name) ;
    virtual DU		get_attr_last_error(CDU name) ;

    // Enable/disable image.

    virtual Result	boot(Timeout to = DEFAULT_TIMEOUT) = 0;
    virtual Waiter	start_boot(CCB cb = NO_CALLBACK) = 0;

	// Anand 12-08-94
    virtual	Result	boot(Array(DU)	attrlist,Timeout to = DEFAULT_TIMEOUT)=0;
    virtual	Waiter	start_boot(Array(DU)	attrlist,CCB cb = NO_CALLBACK)=0;

    virtual Result	shutdown(Timeout to = DEFAULT_TIMEOUT) = 0;
    virtual Waiter	start_shutdown(CCB cb = NO_CALLBACK) = 0;

    // Read real attribute values.

    virtual DU		get     (CDU name, FBits fb = 0) ;
    virtual DU		get_str (CDU name, FBits fb = 0) ;
    virtual long	get_long(CDU name) ;
    virtual GenInt	get_gint(CDU name) ;
    virtual double	get_dbl (CDU name) ;
    virtual Morf	get_raw (CDU name) ;

    // Write imaginary attributes.

    virtual Result	set     (CDU name, CDU           val,
				    CDU op = duREPLACE, FBits fb = 0);
    virtual Result	set_str (CDU name, CDU           val,
				    CDU op = duREPLACE, FBits fb = 0);
    virtual Result	set_long(CDU name, long    val,
				    CDU op = duREPLACE);
    virtual Result	set_gint(CDU name, GenInt& val,
				    CDU op = duREPLACE);
    virtual Result	set_dbl (CDU name, double  val,
				    CDU op = duREPLACE);
    virtual Result	set_raw (CDU name, Morf&   val,
				    CDU op = duREPLACE);

    virtual Result	set_from_ref(Image& refobj);

    // Read imaginary attributes.

    virtual DU		get_set     (CDU name, FBits fb = 0) ;
    virtual DU		get_set_str (CDU name, FBits fb = 0) ;
    virtual long	get_set_long(CDU name) ;
    virtual GenInt	get_set_gint(CDU name) ;
    virtual double	get_set_dbl (CDU name) ;
    virtual Morf	get_set_raw (CDU name) ;

    // Resolve imaginary attributes.

    virtual Result	revert();

    virtual Result	store(Timeout to = DEFAULT_TIMEOUT) = 0;
    virtual Waiter	start_store(CCB cb = NO_CALLBACK) = 0;

    // Object creation, known name.

    virtual Result	create(
		      Image&	refobj = Image(),
		    Timeout		to = DEFAULT_TIMEOUT
		) = 0;
    virtual Waiter	start_create(
		      Image&	refobj = Image(),
		    CCB			cb = NO_CALLBACK
		) = 0;

    // Object creation, known container object.

    virtual Result	create_within(
		    CDU			container_objname,
		      Image&	refobj = Image(),
		    Timeout		to = DEFAULT_TIMEOUT
		) = 0;
    virtual Waiter	start_create_within(
		    CDU			container_objname,
		      Image&	refobj = Image(),
		    CCB			cb = NO_CALLBACK
		) = 0;

    // Object destruction.

    virtual Result	destroy(Timeout to = DEFAULT_TIMEOUT) = 0;
    virtual Waiter	start_destroy(CCB cb = NO_CALLBACK) = 0;

    // Miscellaneous object method activation.

    virtual DU		call(
		    CDU 	name,
		    CDU		param,
		    Timeout	to = DEFAULT_TIMEOUT
		) = 0;
    virtual Morf	call_raw(
		    CDU		name,
		    Morf	param,
		    Timeout	to = DEFAULT_TIMEOUT
		) = 0;

    virtual Waiter	start(
		    CDU		name,
		    CDU		param,
		    CCB		cb = NO_CALLBACK
		) = 0;
    virtual Waiter	start_raw(
		    CDU		name,
		    Morf	param,
		    CCB		cb = NO_CALLBACK
		) = 0;

    virtual Syntax	get_param_syntax(CDU name)   = 0;
    virtual Syntax	get_result_syntax(CDU name)   = 0;

    // Notification.

    virtual Result	when(CDU eventname, CCB cb = NO_CALLBACK) = 0;
    virtual Syntax	get_when_syntax(CDU eventname)   = 0;

    static PlatformData* pldata(Platform &platform);
    static HiClassData*	hcdata(HiClass &hc);
    static MorfData*	mfdata(Morf &mf);
    static ImageData*	imdata(Image &im);
    static AlbumData*	aldata(Album &al);
    static SyntaxData*	sydata(Syntax &sy);
public:
    AttrTracker*	find_attr(CDU name, Boolean create) ;
    operator Image();
};

inline Image::operator void*() { return imd; }

inline int Image::operator !() { return !(void*)*this; }

inline ImageData::operator Image()
{
    Image imn;
    imn.imd = this;
    refcnt++;
    return imn;
}

//****************************************************************************
// Album Data
//****************************************************************************

Arraydeclare(Album);

class AlbumData {
protected:
    friend class	Album;
    friend class	AlbumImage;
    friend class	PlatformData;
    enum AlbumState {DOWN, BOOT, UP, SHUTDOWN};

    U32			refcnt;
    U32			imagecnt;
    Platform		plat;
    DU			derivation;
    DU			nickname;
    DU			ownership;
    DU			access;
    DU			last_error;

    Queue(ImageElem)	imq;

    Hash(DU,DU)		userdata;

    AlbumState		state;
    TrackMode		trackmode;
    Boolean		shared;
    Boolean		autoimage;

    AlbumData() : refcnt(0), imagecnt(0),
		state(DOWN), trackmode(SNAP),
		shared(TRUE), autoimage(FALSE) {}
    AlbumData(  Platform& pl, CDU nick);

    virtual ~AlbumData() {}

    virtual Album	snapshot(CDU newnick = duNO_VALUE);

    // Derives derived albums, nulls out enumerated albums.
    virtual DU		get_derivation() ;
    virtual Result	set_derivation(CDU derivation);

    virtual Result	derive(Timeout to = DEFAULT_TIMEOUT) = 0;
    virtual Waiter	start_derive(CCB cb = NO_CALLBACK) = 0;

	// Anand 08-15-94
    virtual Result	derive(Array(DU)	attrlist,Timeout to = DEFAULT_TIMEOUT)=0;
    virtual Waiter	start_derive(Array(DU)	attrlist,CCB cb = NO_CALLBACK)=0;

    // Manipulate membership of enumerated albums.
    virtual Result	include(Image& im);
    virtual Result	exclude(Image& im);
    virtual Result	include(Album& al);
    virtual Result	exclude(Album& al);

    // Image Iterator.
    AlbumImage		first_image() ;
    virtual U32		num_images()  ;

    // Album information.

    virtual DU		get_prop(CDU key)  ;
    virtual Result	set_prop(CDU key, CDU value);

    // Place where application can store extra info.

    virtual DU		get_userdata(CDU key)  ;
    virtual Result	set_userdata(CDU key, CDU value);

    // Iterate over all images.

    virtual Result	all(
		    Result (*f)(Image& im, void* data),
		    void* data = 0
		);

    virtual Result	all_set_prop(CDU key, CDU value);
    virtual Result	all_set_attr_prop(CDU name, CDU key, CDU value);

    virtual Result	all_boot(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	all_start_boot(CCB cb = NO_CALLBACK);
    virtual Result	all_shutdown(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	all_start_shutdown(CCB cb = NO_CALLBACK);

    virtual Result	all_set     (CDU name, CDU           value,
					CDU op = duREPLACE, FBits fb = 0);
    virtual Result	all_set_str (CDU name, CDU           value,
					CDU op = duREPLACE, FBits fb = 0);
    virtual Result	all_set_long(CDU name, long    value,
					CDU op = duREPLACE);
    virtual Result	all_set_gint(CDU name, GenInt& value,
					CDU op = duREPLACE);
    virtual Result	all_set_dbl (CDU name, double  value,
					CDU op = duREPLACE);
    virtual Result	all_set_raw (CDU name, Morf&   value,
					CDU op = duREPLACE);

    virtual Result	all_set_from_ref(Image& refobj);

    virtual Result	all_revert();

    virtual Result	all_store(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	all_start_store(CCB cb = NO_CALLBACK);

    virtual Result	all_create(  Image& refobj = Image(),
				Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	all_start_create(  Image& refobj = Image(),
				CCB cb = NO_CALLBACK);

    virtual Result	all_create_within(
				CDU container_objname,
				  Image& refobj = Image(),
				Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	all_start_create_within(
				CDU container_objname,
				  Image& refobj = Image(),
				CCB cb = NO_CALLBACK);

    virtual Result	all_destroy(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	all_start_destroy(CCB cb = NO_CALLBACK);

    virtual Result	all_call(CDU name, CDU param, Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	all_start(CDU name, CDU param, CCB cb = NO_CALLBACK);

    virtual Result	all_when(CDU eventname, CCB cb = NO_CALLBACK);

    virtual Result	when(CDU eventname, CCB cb = NO_CALLBACK) = 0;
    virtual Syntax	get_when_syntax(CDU eventname)   = 0;
    virtual void	clude_event(CDU which,   Image& im) = 0;
    void		mark_excludemaybe();
    void		check_excludemaybe();

    static PlatformData* pldata(Platform& pl);
    static ImageData* imdata(Image& im);

    static void all_start_cb(Ptr userdata, Ptr calldata);
public:
    operator Album();
};

inline Album::operator void*() { return ald; }

inline int Album::operator !() { return !(void*)*this; }

inline AlbumData::operator Album()
{
    Album aln;
    aln.ald = this;
    refcnt++;
    return aln;
}

typedef Coder* CoderPtr;
typedef Waiter* WaiterPtr;
typedef Platform* PlatformPtr;
typedef Syntax* SyntaxPtr;
typedef Morf* MorfPtr;
typedef Image* ImagePtr;
typedef AlbumImage* AlbumImagePtr;
typedef Album* AlbumPtr;
typedef CurrentEvent* CurrentEventPtr;

/*********************Globals Required For Exception and Error Handling */
extern Exception *exception;
extern ExceptionValue cur_except;
extern Error   error;
/************************************************************************/

#endif /* __HI_H__ */
