// Copyright 16 Aug 1995 Sun Microsystems, Inc. All Rights Reserved.
//
#pragma ident  "@(#)hi_d3.hh	1.21 95/08/16 Sun Microsystems"
// Copyright 16 Aug 1995 Sun Microsystems, Inc. All Rights Reserved.
//
#pragma ident  "@(#)hi_d3.hh	1.21 95/08/16 Sun Microsystems"
// Copyright 24 Aug 1994 Sun Microsystems, Inc. All Rights Reserved.
#pragma ident "@(#)hi_d3.hh	1.8 94/08/24 Sun Microsystems"
/***********************************************************
 *
 * $Header: /export/dimons3g/dimons3g/src/./cfm/RCS/hi_d3.h,v 1.21 1993/08/10 18:45:58 lwall Exp $
 *
 * Copyright 1990, 1991, 1992, 1993 NetLabs, Incorporated, 4920 El Camino Real,
 * Los Altos, CA 94022, USA.
 *
 *                       ALL RIGHTS RESERVED
 *
 * This software, and the ideas, mechanisms and algorithms expressed
 * therein, is the intellectual and material property of NetLabs,
 * Incorporated, and is provided for use under applicable license agreement
 * only.  No title to or ownership of the software is hereby transferred.
 * No license to copy, modify, distribute, translate, decompile, reverse
 * engineer or otherwise remanufacture this software except under the above
 * license is granted.
 *
 *  Notice:  Notwithstanding any other lease or license that may pertain to,
 #  or accompany the delivery of, this computer software, the rights of the
 *  Government regarding its use, reproduction and disclosure are as set
 *  forth in Section 52.227-19 of the FARS Computer Software-Restricted
 *  Rights clause.
 *
 *  (c) Copyright 1990, 1991, 1992, 1993 NetLabs, Inc.  Unpublished - all
 *  rights reserved under the Copyright laws of the United States.
 *
 *  RESTRICTED RIGHTS NOTICE:  Use, duplication, or disclosure by the
 *  Government is subject to the restrictions as set forth in subparagraph
 *  (c)(1)(ii) of the Rights in Technical Data and Computer Software clause
 *  at DFARS 52.227-7013.
 *
 *  NetLabs, Inc.
 *  4920 El Camino Real
 *  Los Altos, CA 94022
 *  (415)961-9500
 *
 *  RESTRICTED RIGHTS LEGEND:  This computer software is submitted with
 *  restricted rights.  Use, duplication or disclosure is subject to the
 *  restrictions as set forth in NASA FAR SUP 18-52.227-79 (April 1985)
 *  Commercial Computer Software- Restricted Rights (April 1985). NetLabs,
 *  Inc., 4920 El Camino Real, Los Altos, CA  94022.  If the contract
 *  contains the Clause at 18-52.227-74 "Rights in Data General" then the
 *  "Alternate III" clause applies.
 *
 * Description:
 *      DiMONS3g-specific hi-level API definitions.
 *
 * Created:
 *      Tue March 23 01:22:55 1993
 *
 * Author:
 *      Larry Wall <lwall@netlabs.com>
 *
 * $Log: hi_d3.h,v $
 * Revision 1.21  1993/08/10  18:45:58  lwall
 * NETaa09247
 * Rapid events caused stack overflow.
 * NETaa09247
 *
 * Revision 1.20  1993/06/21  23:29:27  lwall
 * Added explicit copyright notice.
 *
 * Revision 1.19  1993/06/21  23:24:53  lwall
 * Didn't scope into incomplete Cellnet Mib.
 *
 * Revision 1.18  1993/06/18  00:12:24  lwall
 * Made HI API work with new obed.  Too many changes to enumerate here.
 *
 * Revision 1.17  1993/06/11  06:26:34  lwall
 * Made Coder into a handle class.
 *
 * Revision 1.16  1993/06/08  21:12:44  lwall
 * mNETaa08365 NETaa08369
 * Added CurrentEvent::get_eventtype() method.  Moved string  ants to hi.h.
 * Added CurrentEvent::get_eventtype() method.  Moved string  ants to hi.h.
 * Added CurrentEvent::get_eventtype() method.  Moved string  ants to hi.h.
 * Added CurrentEvent::get_eventtype() method.  Moved string  ants to hi.h.
 *
 * Revision 1.14  1993/06/05  09:22:51  lwall
 * Added Coder registries for bug NETaa08319.  Worked around Lucid bug.
 * Straigtened out some differences between document and files.
 *
 * Revision 1.13  1993/05/29  00:42:51  lwall
 *  Added Morf::has_value().
 *
 * Revision 1.12  1993/05/27  23:30:34  lwall
 * Added header.
 *
 *
 **********************************************************/

#ifndef __HI_D3_H__
#define __HI_D3_H__

#define CMOT_PORT 5555

#include "hi.hh"
#include "asn1_val.hh"
#include "asn1_type.hh"

#include "address.hh"
#include "message.hh"
#include "debug.hh"
#include "except.hh"
#include "exceptstd.hh"
#include "filter.hh"

#include "app_msg.hh"

//****************************************************************************
// Encoder/decoder management
//****************************************************************************

class OiCoderData : public CoderData {
public:
    virtual DU          get_str(Morf& mf, FBits fb);
    virtual Morf&       set_str(Morf& mf, CDU data, FBits fb);

    OiCoderData(  Platform& pl) : CoderData(pl) {}
    virtual ~OiCoderData() {}
};

//****************************************************************************
// Platform management
//****************************************************************************

class WhenElem : public QueueElem {
public:
    DU name;
    Callback cb;
    WhenElem(CDU n, CCB c) : name(n), cb(c) {}
};

Queuedeclare(WhenElem);

class WhenList {
    Queue(WhenElem)	whenq;
public:
    Result		when(CDU eventname, CCB cb);
    void		dispatch(CDU eventname, CurrentEvent& ce)  ;
    static Syntax	syntax(CDU eventname, Platform& plat);
};

class D3PlatformData : public PlatformData {
protected:
    friend class OiCoderData;
    friend class D3AlbumData;
    friend class D3CurrentEventData;
    friend class D3HiClassData;
    friend class D3ImageData;
    friend class D3MorfData;
    friend class D3SyntaxData;
    friend class ATDataChoice;
    friend class Platform;

    ApplMessageSAP	*sap;
    Address		source_module;
    MessId		message_id;
    WhenList		whenlist;
    Queue(AlbumElem)	track_q;
    Queue(Message)	notify_q;

    D3PlatformData();
    D3PlatformData(const PlatformId id, CDU nickname = DU(""));

    virtual ~D3PlatformData() {}

//    virtual Result	set_prop(CDU key, CDU value);
//    virtual DU		get_prop(CDU key);

    // Establish connection to a platform.

    virtual Result	connect(
		    CDU		location,
		    CDU		application_name,
		    const Timeout	to = DEFAULT_TIMEOUT
		);
    virtual Waiter	start_connect(
		    CDU		platform,
		    CDU		application_name,
		    CCB		cb = NO_CALLBACK
		);

    static void receive_request(Ptr userdata, Ptr calldata);
    static void disconnected(Ptr userdata, Ptr calldata);

    // Tear down connection to a platform.

    virtual Result	disconnect(const Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	start_disconnect(CCB cb = NO_CALLBACK);

    virtual Result	when(CDU eventname, CCB cb = NO_CALLBACK);
    virtual Syntax	get_when_syntax(CDU eventname);

    void init_dimons3g_types();

    virtual DU		get_fullname(CDU shortname)  ;
    virtual DU		get_shortname(CDU fullname)  ;
    virtual DU		canonicalize_objname(CDU name)  ;
    Result		request_events()  ;

    virtual void*	get_raw_sap() { return (void*)sap; }

    virtual void	process_event(CurrentEvent& ce)  ;

public:
    Asn1Value		name2oi(CDU name, DU& remainder,
					Boolean fdn = FALSE)  ;
    DU			oi2name(  Asn1Value av)  ;
};

//****************************************************************************
// Syntax.
//****************************************************************************

class D3SyntaxData : public SyntaxData {
protected:
    friend class D3AlbumData;
    friend class D3ImageData;
    friend class D3MorfData;
    friend class D3PlatformData;
    friend class Syntax;
    friend class WhenList;

    Asn1Type		type;
    DU			text;
    Array(Syntax)	memsyn;
    Array(DU)		memname;

    D3SyntaxData(Platform &p, CDU text);
    D3SyntaxData(Platform &p, Morf &mf);
    D3SyntaxData(Platform &p,   Asn1Type &at, CDU nm = duNO_VALUE);
    D3SyntaxData(CDU attrname,   Platform& p);

    virtual ~D3SyntaxData() {}

    virtual operator void*()  ;

    virtual Boolean	is_list()  ;
    virtual Boolean	is_choice()  ;
    virtual Boolean	is_any()  ;
    virtual DU		get(FBits fb = 0)  ;
    virtual Morf	get_raw() ;
    virtual Syntax	expansion()  ;
    virtual Syntax	member(DU name)  ;
    virtual Array(DU)	get_member_names()  ;
    void		find_memname(D3MorfData* mfd);
public:
    Asn1Type		get_type()   { return type; }
};

//****************************************************************************
// Mysterious Object Related to Framework
//****************************************************************************

class D3MorfData : public MorfData {
protected:
    friend class Morf;
    friend class OiCoderData;
    friend class D3AlbumData;
    friend class D3CurrentEventData;
    friend class D3ImageData;
    friend class D3PlatformData;
    friend class D3SyntaxData;
	friend class D3HiFilter;

    Asn1Value		val;

    D3MorfData() {}
    D3MorfData(Syntax &s);
    D3MorfData(Syntax &s,   Asn1Value &av);
    D3MorfData(Syntax &s, CDU data);
    D3MorfData(Syntax &s,   Array(Morf)& ma);
    D3MorfData(Syntax &s,   Queue(MorfElem)& mq);

    void		join_array(  Array(Morf)& ma);

    virtual ~D3MorfData() {}

    virtual void*	has_value()  ;

    virtual int operator == (const Morf& other) ;

    virtual Array(Morf)	split_array() ;		// list only
    virtual Queue(MorfElem) split_queue()  ;	// list only
    virtual Morf	extract(CDU navigation) ;	// list only
    virtual U32		num_elements() ;		// list only
	
    virtual Morf	set     (CDU data, FBits fb = 0);// either
    virtual Morf	set_str (CDU data, FBits fb = 0);// scalar only
    virtual Morf	set_long(long data);	// scalar only
    virtual Morf	set_gint(GenInt& data);	// scalar only
    virtual Morf	set_dbl (double data);	// scalar only
    virtual Morf	set_any (Morf& data);	// any only

    virtual DU		get(FBits fb = 0) ;	// either
    virtual DU		get_str(FBits fb = 0) ;	// scalar only
    virtual long	get_long()  ;		// scalar only
    virtual GenInt	get_gint()  ;		// scalar only
    virtual double	get_dbl()  ;		// scalar only

    Asn1Value		get_val()   { return val; }

    virtual Result      set_memname(CDU name);          // choice only
    virtual Array(DU)   get_member_names()  ;

public:
    static DU		oi_getter(  Morf& mf, FBits fb);
    static Morf&	oi_setter(Morf& mf, CDU data, FBits fb);

    Asn1Value		get_value() { return val; }
    void                set_value(Asn1Value &v) { val = v;}
};

//****************************************************************************
// Class management
//****************************************************************************

class D3HiClassData : public HiClassData {
protected:
    friend class HiClass;

    Asn1Value		avoc;
    Boolean		snabbed_metadata;

public:

    D3HiClassData(CDU oc,   Platform& pl);
    virtual void	load_attr_info();

    virtual ~D3HiClassData() {}

    Asn1Value oc() {
	if (!snabbed_metadata)
	    snab_data();
	return avoc;
    }
    void snab_data();	// Getting the class data saves getting the attr data...

protected:
    virtual void	load_attr_info(ImageData* imd)  ;
    void		parse_objectclass(  Asn1Value& av);
    void		really_snab_data();
};

//****************************************************************************
// Image management
//****************************************************************************

enum ImageOperation {
    OP_BOOT,
    OP_SHUTDOWN,
    OP_STORE,
    OP_CREATE,
    OP_CREATE_WITHIN,
    OP_DESTROY,
    OP_START,
    OP_START_RAW
};

class D3ImageOp {
public:
    ImageOperation	op;			
    D3ImageData*	imd;
    Image		im;
    DU			nm;
    DU			pr;
    Morf		mf;
    Boolean		docb;
    D3ImageOp(D3ImageData* d, ImageOperation o, Boolean c)
	: imd(d), op(o), docb(c) {}
    D3ImageOp(D3ImageData* d, ImageOperation o, Boolean c,   Image& i)
	: imd(d), op(o), docb(c), im(i) {}
    D3ImageOp(D3ImageData* d, ImageOperation o, Boolean c, CDU n,   Image&i)
	: imd(d), op(o), docb(c), nm(n), im(i) {}
    D3ImageOp(D3ImageData* d, ImageOperation o, Boolean c, CDU n, CDU p)
	: imd(d), op(o), docb(c), nm(n), pr(p) {}
    D3ImageOp(D3ImageData* d, ImageOperation o, Boolean c, CDU n,   Morf& p)
	: imd(d), op(o), docb(c), nm(n), mf(p) {}
};

class D3ImageData : public ImageData {
protected:
    friend class Image;
    friend class D3AlbumData;
    friend class D3PlatformData;
	friend class D3HiFilter;
    Waiter		curwaiter;
    Blockage		starters;
    Asn1Value		oi;
    WhenList		whenlist;
    Boolean		busy;

	// Anand 12-20-94
	Asn1Value get_oi(void)
	{
		return oi;
	}

	// Anand 12-07-94
	Result  send_event(DU event_name, DU event_info=DU(), struct tm *time=0);
	Result  send_event(DU event_name, Asn1Value &event_info, Asn1Value &tm);

    D3ImageData(CDU objname, CDU objclass,   Platform &p);
	// 08-18-94 Anand: Performance try while deriving
    D3ImageData(CDU objname, CDU objclass,   Platform &p, Asn1Value &in_oi);

	//  Anand 12-20-94
    D3ImageData(Asn1Value& oi, Asn1Value& oc,   Platform &p);

    virtual ~D3ImageData();

    // These methods serialize all operations on this Image.
    Boolean		my_turn(Waiter& wait);
    void		your_turn();
    static void		restart_something_cb(Ptr, Ptr);
    void		wakeup_something() {
	if (!busy && starters.size())
	    starters.wakeup_first();
    }

    // These return TRUE if the operation is still waiting to complete.
    Boolean		really_boot(Array(DU) attrlist = Array(DU)());
    Boolean		really_shutdown();
    Boolean		really_store();
    Boolean		really_create();
    Boolean		really_create_within();
    Boolean		really_destroy();
    Boolean		really();
    Boolean		really_raw();

    // Check for D3-specific properties (TRACKMODE).
    virtual Result      set_prop(CDU key, CDU value);

    // Enable/disable image.

    virtual Result	boot(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	start_boot(CCB cb = NO_CALLBACK);

	// Anand 12-08-94
    virtual Result	boot(Array(DU)	attrlist,Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	start_boot(Array(DU)	attrlist,CCB cb = NO_CALLBACK);

    virtual Result	shutdown(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	start_shutdown(CCB cb = NO_CALLBACK);

    virtual Result	store(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	start_store(CCB cb = NO_CALLBACK);

    // Object creation, known name.

    virtual Result	create(
		      Image&	refobj = Image(),
		    Timeout		to = DEFAULT_TIMEOUT
		);
    virtual Waiter	start_create(
		      Image&	refobj = Image(),
		    CCB			cb = NO_CALLBACK
		);

    // Object creation, known container object.

    virtual Result	create_within(
		    CDU			container_objname,
		      Image&	refobj = Image(),
		    Timeout		to = DEFAULT_TIMEOUT
		);
    virtual Waiter	start_create_within(
		    CDU			container_objname,
		      Image&	refobj = Image(),
		    CCB			cb = NO_CALLBACK
		);

    // Object destruction.

    virtual Result	destroy(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	start_destroy(CCB cb = NO_CALLBACK);

    // Miscellaneous object method activation.

    virtual DU		call(
		    CDU 	name,
		    CDU		param,
		    Timeout	to = DEFAULT_TIMEOUT
		);
    virtual Morf	call_raw(
		    CDU		name,
		    Morf	param,
		    Timeout	to = DEFAULT_TIMEOUT
		);

    virtual Waiter	start(
		    CDU		name,
		    CDU		param,
		    CCB		cb = NO_CALLBACK	// XXX Raw void* data?
		);
    virtual Waiter	start_raw(
		    CDU		name,
		    Morf	param,
		    CCB		cb = NO_CALLBACK
		);

    virtual Syntax	get_param_syntax(CDU name)  ;
    virtual Syntax	get_result_syntax(CDU name)  ;
    Syntax		get_param_stuff(CDU name, char* which, Asn1Value& oidav)
								     ;

    // Notification.

    virtual Result	when(CDU eventname, CCB cb = NO_CALLBACK);
    virtual Syntax	get_when_syntax(CDU eventname)  ;

    static void		start_boot_cb(Ptr userdata, Ptr calldata);
    Result		process_get_response(ResponseHandle rh);

//  static void		start_shutdown_cb(Ptr userdata, Ptr calldata);
//  Result		process_set_response(ResponseHandle rh);

    static void		start_store_cb(Ptr userdata, Ptr calldata);
    Result		process_set_response(ResponseHandle rh);

    static void		start_create_cb(Ptr userdata, Ptr calldata);
    Result		process_create_response(ResponseHandle rh);

    static void		start_create_within_cb(Ptr userdata, Ptr calldata);
//  Result		process_create_response(ResponseHandle rh);

    static void		start_destroy_cb(Ptr userdata, Ptr calldata);
    Result		process_delete_response(ResponseHandle rh);

    static void		start_cb(Ptr userdata, Ptr calldata);
    Result		process_action_response(ResponseHandle rh, Waiter&wait);

    Result              assert_real_val(  Asn1Value& ava, Boolean store);
    Result              assert_unreal_val(  Asn1Value& ava);

    virtual void	process_event(CDU name, CurrentEvent& ce)  ;
    static void		do_attrchanged(Ptr userdata, Ptr calldata);
    static void		do_objdestroyed(Ptr userdata, Ptr calldata);
    static void		do_objcreated(Ptr userdata, Ptr calldata);
};

//****************************************************************************
// Album management
//****************************************************************************

class D3AlbumData : public AlbumData {
protected:
    friend class Album;
    friend class D3ImageData;
    friend class D3PlatformData;

    Asn1Value		oi;
    U32			min;
    U32			max;
	Asn1Value       filter;
	MessScope       scope;

    Blockage		serial_q;
    WhenList		whenlist;
    Boolean		in_callback;

    D3AlbumData() : in_callback(FALSE) {}
    D3AlbumData(  Platform& pl, CDU nick);

    virtual ~D3AlbumData();

    virtual Result      set_prop(CDU key, CDU value);

    virtual Album	snapshot(CDU newnick = duNO_VALUE);

    virtual Result	derive(Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	start_derive(CCB cb = NO_CALLBACK);

	// Anand 08-15-95
    virtual Result	derive(Array(DU)	attrlist,Timeout to = DEFAULT_TIMEOUT);
    virtual Waiter	start_derive(Array(DU)	attrlist,CCB cb = NO_CALLBACK);

    // Album information.

//  virtual DU		get_prop(CDU key)  ;
//  virtual Result	set_prop(CDU key, CDU value);

    virtual Result	when(CDU eventname, CCB cb = NO_CALLBACK);
    virtual Syntax	get_when_syntax(CDU eventname)  ;
    virtual void	process_event(CDU name, CurrentEvent& ce)  ;
    virtual void        clude_event(CDU which,   Image& im);
    static void		cancel_get_cb(Ptr userdata, Ptr calldata);
    static void		cancel_get_response_cb(Ptr userdata, Ptr calldata);
    static void		start_derive_cb(Ptr userdata, Ptr calldata);
    void		wakeup_something();
    static void		really_derive_cb(Ptr userdata, Ptr calldata);
    Result		process_get_response(MessagePtr msg, Boolean ignore);
    static void		do_objdestroyed(Ptr userdata, Ptr calldata);
    static void		do_objcreated(Ptr userdata, Ptr calldata);
    Boolean		matches_derivation(CurrentEvent& ce)  ;
	virtual Waiter  all_start_destroy(CCB cb = NO_CALLBACK);
    static void     all_start_destroy_cb(Ptr userdata, Ptr calldata);

};

//****************************************************************************
// Current Event Management
//****************************************************************************

class D3CurrentEventData : public CurrentEventData {
protected:
    friend class D3PlatformData;
    friend class D3AlbumData;
    friend class D3HiClassData;

    D3CurrentEventData(  Platform& pl, Ptr rm) : CurrentEventData(pl, rm) {}
    D3CurrentEventData(  Platform& pl,   Album &al,   Image& im)
	: CurrentEventData(pl, 0)
    {
	album = al;
	image = im;
    }

    ~D3CurrentEventData() {
	if (message)
	    Message::delete_message(MessagePtr(message));
    }

    virtual Morf	get_event_raw()  ;

	virtual Asn1Value	get_oi();
	virtual Asn1Value	get_oc();

    virtual DU		get_objname()  ;
    virtual DU		get_objclass()  ;
    virtual DU		get_time()  ;
    virtual Oid		get_oid()  ;
    virtual DU		get_name()  ;
    virtual Morf	get_info_raw()  ;
    virtual Image	get_image(Boolean create = FALSE)  ;
};



void delasn1val(Ptr p);
Hashdeclare(Oid,Asn1Value,Oid::hash,Oid::equiv,deldu,delasn1val)

/*
 * 	HAPI's idea of a filter, derived from filter.
 *
 *	The basic idea here is that the filter calls us back 
 *	for the need_value and need_type information. Each of
 *	these routines provides the type and value via the
 *	provide_type and provide_value member funcs. The filter implementation
 *	then calls end_filter with the result.
 */
class D3HiFilter:  public Filter {
private:
    CurrentEvent	cur_ev;
public:
    FilterResult	filter_result;
    Boolean		active;
    Hash(Oid,Asn1Value)	cache;

    D3HiFilter:: D3HiFilter( Asn1Value filter, CurrentEvent ce )
	: Filter(filter), cur_ev(ce), filter_result(INVALID), active(TRUE)
    {}

    ~D3HiFilter() {}

    Result need_type( const Asn1Value &attr_name); 

    Result need_value(const Asn1Value &attr_name); 

    void  end_filter(FilterResult fr) {
	filter_result = fr;
	active = FALSE;
    }
};
#endif /* __HI_D3_H__ */
